AnimeCentral/urls.py
from django.conf import settings
from django.conf.urls import include
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path

urlpatterns = [
    path('',include('front_end.urls')),
    path('api/',include('animedata.urls')),
    path('api/',include('reviews.urls')),
    path('admin/', admin.site.urls),
    path('blog/', include('blog.urls')),
]+ static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

blog/urls.py
from django.urls import path

from . import views

app_name = 'blog'

urlpatterns = [
    path('', views.post_list, name='post_list'),
    path('post/<int:pk>/', views.post_detail, name='post_detail'),
    path('post/new', views.post_new, name='post_new'),
    path('post/<int:pk>/edit/', views.post_edit, name='post_edit'),
    path('post/delete/<int:pk>/', views.delete_post, name='delete-post'),
    path('user/', views.UserList.as_view()),
    path('user/<int:pk>', views.UserDetails.as_view()),
    path('blog_details', views.Blogs_list.as_view(), name='blog-detail'),
    path('blog_details/<int:pk>', views.Blogs_details.as_view(), name='blog-detail'),
]

front_end/urls.py
from django.contrib import admin
from django.urls import path, include
from .views import anime_detail
from django.conf.urls import url
from . import views

app_name = 'front_end'

urlpatterns = [
    path('anime/<int:pk>/', views.anime_detail, name='anime-detail'),
    path('anime/', views.anime_list),
    path('anime/search/', views.anime_search, name='anime-search'),
    path('anime/list/', views.anime_list, name='anime-list'),
    path('anime/reviews/', views.anime_review, name='anime-review'),
    path('anime/reviews/<int:pk>/', views.post_review, name='post-review'),
    path('anime/reviews/delete/<int:pk>/', views.delete_review, name='delete-review'),
    path('profile/reviews/edit/<int:pk>/', views.edit_review, name='edit-review'),
    path('', views.anime_carousal, name='home'),
    path('register/', views.register, name='register'),
    path('login/', views.user_login, name='login'),
    path('logout/', views.user_logout, name='logout'),
    path('profile/', views.user_profile, name='user-profile'),
    path('profile/watch_list/', views.watch_list, name='watch-list'),
    path('profile/<int:pk>/', views.profile, name='profile'),
    ]

blog/models.py
from django.db import models
from django.utils import timezone


class Post(models.Model):
    author = models.ForeignKey('auth.User', on_delete=models.CASCADE)
    title = models.CharField(max_length=200)
    text = models.TextField()
    created_date = models.DateTimeField(
            default=timezone.now)
    published_date = models.DateTimeField(
            blank=True, null=True)

    def publish(self):
        self.published_date = timezone.now()
        self.save()
    class Meta:
        ordering = ('created_date',)

    def __str__(self):
        return self.title

blog/forms.py
from django import forms

from .models import Post

class PostForm(forms.ModelForm):
    title = forms.CharField(
        max_length=30,
        widget=forms.TextInput(
            attrs={
                'placeholder': 'Write your title here'
            }
        )
    )

    text = forms.CharField(
        max_length=2000,
        widget=forms.Textarea(attrs={'placeholder': 'Write your Post here'})
    )

    class Meta:
        model = Post
        fields = ('title', 'text',)

blog/views.py
from django.shortcuts import render

# Create your views here.
from django.shortcuts import redirect
from django.shortcuts import render, get_object_or_404
from django.utils import timezone
from rest_framework import generics
from django.contrib.auth.models import User
from .serializers import UserSerializer, BlogsSerializer
from front_end.models import UserProfile
from django.contrib.auth.decorators import login_required
from .forms import PostForm
from .models import Post
from django.http import HttpResponseRedirect, HttpResponse
from django.urls import reverse

def post_list(request):

    posts = Post.objects.values("id","title","text","created_date","published_date","author__username","author").order_by("-published_date")
    # user = {}
    # for post in posts:
    #     print("-------------")
    #     print(post)
    #     image_url = UserProfile.objects.values('profile_pic').get(user=post['author'])
    #
    #     user[post['author']] = image_url['profile_pic']
    # print(user)
    return render(request, 'blog/post_list.html', {'posts': posts})


def post_detail(request, pk):
    post = get_object_or_404(Post, pk=pk)
    return render(request, 'blog/post_detail.html', {'post': post})


def post_new(request):
    if request.method == "POST":
        form = PostForm(request.POST)
        if form.is_valid():
            post = form.save(commit=False)
            post.author = request.user
            post.published_date = timezone.now()
            post.save()
            return redirect('blog:post_list')
    else:
        form = PostForm()
    return render(request, 'blog/post_edit.html', {'forms': form})


def post_edit(request, pk):
    post = get_object_or_404(Post, pk=pk)
    if request.method == "POST":
        form = PostForm(request.POST, instance=post)
        if form.is_valid():
            post = form.save(commit=False)
            post.author = request.user
            post.published_date = timezone.now()
            post.save()
            return redirect('blog:post_list')
    else:
        form = PostForm(instance=post)
    return render(request, 'blog/post_edit.html', {'forms': form})

#delete a review
@login_required
def delete_post(request, pk):
    post = get_object_or_404(Post, pk=pk)
    if post.author == request.user:
        print('working')
        Post.objects.filter(id=pk).delete()
        return HttpResponseRedirect(reverse('front_end:user-profile'))
    return HttpResponseRedirect(reverse('front_end:user-profile'))

#-----------------------------API----------------------------------------#

class UserList(generics.ListAPIView):
    queryset = User.objects.all()
    serializer_class = UserSerializer

class UserDetails(generics.RetrieveUpdateDestroyAPIView):
    queryset = User.objects.all()
    serializer_class = UserSerializer

class Blogs_list(generics.ListAPIView):
    queryset = Post.objects.all()
    serializer_class = BlogsSerializer

class Blogs_details(generics.RetrieveUpdateDestroyAPIView):
    queryset = Post.objects.all()
    serializer_class = BlogsSerializer

blog/templates/blog/base.html
{% load static %}

blog/templates/blog/core_base.html
{% load static %}
<!DOCTYPE html>
<html lang="en" dir="ltr">

<head>
    <meta charset="utf-8">
    <link href="http://allfont.net/allfont.css?fonts=agency-fb" rel="stylesheet" type="text/css"/>
    <link rel="stylesheet" href="{% static 'css/base.css' %}">
    {% block style %}
    <link rel="stylesheet" href="{% static 'css/main.css' %}">
    {% endblock style %}
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-beta/css/bootstrap.min.css"
          integrity="sha384-/Y6pD6FV/Vv2HJnA6t+vslU6fwYXjCFtcEpHbNJ0lyAFsXTsjBbfaDjzALeQsN6M" crossorigin="anonymous">
    <title></title>
</head>
<body>
<div class="main_container">
    <!-- header top logo -->
    <div class="anime_logo">
        <a href="#"><span class="logo">Anime Central</span></a>
        {% if user.is_authenticated %}
        <a>
            <button class="login">Logout</button>
        </a></li>
        {% else %}
        <a>
            <button class="login">Login</button>
        </a></li>
        <a>
            <button class="register">Register</button>
        </a></li>
        {% endif %}
    </div>
    <!-- nav bar under logo -->
    <div class="top_nav">
        <a href="#home">Anime</a>
        <a href="#news">Blog</a>
        <a href="#contact">Reviews</a>
        <div class="search-container">
            <form>
                <input type="text" placeholder="Search" name="search">
            </form>
        </div>
    </div>
    <!--body  -->
    <div class="body_block">
        {% block body %}

        {% endblock body %}

    </div>


    <!--footer  -->
    <div class="anime_bottom">
        <a href="#home">Home</a>
        <a href="#news">About</a>
        <a href="#contact">Contact Us</a>
        <div class="follow_us">
            <p>Follow Us:</p>
            <a href="#"><img src="{% static 'assets/facebook.png' %}" alt=""> </a>
            <a href="#"><img src="{% static 'assets/instagram.png' %}" alt=""> </a>
        </div>
    </div>

</div>
</body>
</html>

blog/templates/blog/post_detail.html
{% extends 'front_end/base.html' %}

{% block body %}
    <div class="post">
        {% if post.published_date %}
            <div class="date">
                {{ post.published_date }}
            </div>
        {% endif %}
        <h1 style="color: #3dc6c6;"><a style="color: #3dc6c6;" {% if user.username %} href="{% url 'post_edit' pk=post.pk %}" {% endif %}>{{ post.title }}</a></h1>
        <p>{{ post.text|linebreaksbr }}</p>
    </div>
{% endblock %}

blog/templates/blog/post_edit.html
    {% extends 'front_end/base.html' %}
    {% load static %}
    {% block style %}
    <link rel="stylesheet" href="{% static 'css/post_edit.css' %}">
    {% endblock style %}
    {% block body %}
    <div class="form_edit">
        <h1>New post</h1>
        <form method="POST" class="post-form">{% csrf_token %}
            {% for form in forms %}
            <h3> {{ form }} </h3>
            <!--<h3> {{ forms.as_p }} </h3>-->
            {% endfor %}

            <button type="submit" class="save btn btn-default">Save</button>
        </form>
    </div>
    {% endblock %}

blog/templates/blog/post_list.html
{% extends 'front_end/base.html' %}
{% load static %}
{% block body %}
<head>
    <title>Anime blog</title>
    <link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap.min.css">
    <link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap-theme.min.css">
    <link href='//fonts.googleapis.com/css?family=Lobster&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
    <link rel="stylesheet" href="{% static 'css/blog.css' %}">
    <link rel='stylesheet' href="{% static 'css/main.css' %}">
    <a href="{% url 'blog:post_new' %}" class="top-menu"><span class="glyphicon glyphicon-plus"></span></a>
</head>
<body class='body'>
 <h5 class='profile-name'>Blogs:</h5>
    {% for post in posts %}
    <div class='post-container'>
        <div class='post-header'>
            <div class='header-img'>
                <img height='144' src="https://myanimelist.cdn-dena.com/images/anime/12/35893.jpg"/>
                
            </div>
            <div  class='header-text'>
                <h5>Title: {{ post.title }}</h5>
                <p>Created on: {{ post.published_date }}<br>
                Author: <a href="{% url 'front_end:profile' post.author %}">{{ post.author__username }}</a></p>
                <p>{{ post.text }}</p>
            </div>
        </div>
        {% if not forloop.last %}
            <hr>
        {% endif %}
    </div>
    {% endfor %}
</body>


{% endblock %}